#!/bin/sh

GRID_SECURITY=/etc/grid-security
HOST_JKS=${GRID_SECURITY}/hostcert.ks
CA_JKS=${GRID_SECURITY}/certificates.ts

TMPFILE=$(mktemp) || exit 1

for i in ${GRID_SECURITY}/certificates/*.0 ; do
    j=$(echo $i | sed -e 's_.*/__g;s/\.0$//')
    cat $i | grep -A 100 "BEGIN CERTIFICATE-----" > $TMPFILE
    keytool -importcert -keystore $CA_JKS.$$ -noprompt \
            -storepass changeit -alias $j -file $TMPFILE \
        || echo -e "\n\tFAILED: $i\n"
done

mv -f $CA_JKS.$$ $CA_JKS

openssl pkcs12 -export \
    -in $GRID_SECURITY/hostcert.pem -inkey $GRID_SECURITY/hostkey.pem \
    -passout pass:changeit -out $TMPFILE

keytool -importkeystore -srckeystore $TMPFILE -srcstorepass changeit \
    -destkeystore $HOST_JKS.$$ -srcstoretype pkcs12 \
    -deststoretype jks -deststorepass changeit

rm -f $TMPFILE

mv -f $HOST_JKS.$$ $HOST_JKS

